<?php

if (!defined('TOBBIVM')) header('location:/template/notrepassing.php');
/**
 * This file is part of TobbiVMShop.
 *
 * TobbiVMShop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TobbiVMShop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TobbiVMShop.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Edit pdf-settings for printig order list E-Mail->Orders
 * use list.tpl.php
 * 
 * @version    $Id$
 * @package    TobbiVM-Shop
 * @copyright  Copyright (C) 2016
 * @author     Norbert Gebert
 * @license    GPL3
 */
function contentPage($refPage, $page, $subpage, $refValidate)
{
	if (isset($_REQUEST['submit']))
	{
		if ($refValidate->cleanslash($_REQUEST['submit']) === _('Save'))
		{ // Update the database
			$pagefile = 'module/page/config/list.page.save.php';
			if (is_file($pagefile)) include_once $pagefile;
		}
	}

	db::getInstance()->where('config_key', 'printlist');
	$result = db::getInstance()->getOne('config' . SUFFIX);
	$config = array();

	//Create config data
	// Paperdimension
	$configRows = explode('|', $result['config_text']);
	foreach ($configRows as $row)
	{
		$field = explode(':', $row);
		$config[$field[0]] = $field[1];
	}

	$refPage->assign('title', _('PDF settings for order list'));
	$refPage->assign('action', 'index2.php?page=' . $page . '&sub=' . $subpage);

	
	$refPage->assign('title1', _('Papersize (Dimensions in mm)'));

	$refPage->assign('height', _('Page height') . ':');
	$refPage->assign('heightx',
			  '<input type="text" name="heightx" id="heightx" size="5"' .
			  'value="' . $config['height'] . '" />');
	$refPage->assign('pdfheightxHelp', help('pdflistheight', $page));

	$refPage->assign('width', _('Page width') . ':');
	$refPage->assign('widthx',
			  '<input type="text" name="widthx" id="widthx" size="5"' .
			  'value="' . $config['width'] . '" />');
	$refPage->assign('pdfwidthxHelp', help('pdflistwidth', $page));

	$refPage->assign('topMarging', _('Top margin') . ':');
	$refPage->assign('topMargingx',
			  '<input type="text" name="topMargingx" id="topMargingx" size="5"' .
			  'value="' . $config['topmargin'] . '" />');
	$refPage->assign('pdftopmargingxHelp', help('pdflisttopmarging', $page));

	$refPage->assign('leftMarging', _('Left margin') . ':');
	$refPage->assign('leftMargingx',
			  '<input type="text" name="leftMargingx" id="leftMargingx" size="5"' .
			  'value="' . $config['leftmargin'] . '" />');
	$refPage->assign('pdfleftmargingxHelp', help('pdflistleftmarging', $page));

	// Rowfields =========================================================
	$refPage->assign('title2', _('Width of Fields (Dimensions in mm)'));

	$refPage->assign('numberWidth', _('No.') . ':');
	$refPage->assign('numberWidthx',
			  '<input type="text" name="numberWidthx" id="numberWidthx" size="5"' .
			  'value="' . $config['no'] . '" />');
	$refPage->assign('pdfnumberWidthxHelp', help('pdflistnumber', $page));

	$refPage->assign('dateWidth', _('Date') . ':');
	$refPage->assign('dateWidthx',
			  '<input type="text" name="dateWidthx" id="dateWidthx" size="5"' .
			  'value="' . $config['date'] . '" />');
	$refPage->assign('pdfdateWidthxHelp', help('pdflistdate', $page));

	$refPage->assign('customerNumberWidth', _('Customer Number') . ':');
	$refPage->assign('customerNumberWidthx',
			  '<input type="text" name="customerNumberWidthx" id="customerNumberWidthx" size="5"' .
			  'value="' . $config['customerno'] . '" />');
	$refPage->assign('pdfcustomernumberWidthxHelp', help('pdflistcustomernumber', $page));
	
	$refPage->assign('customerNameWidth', _('Customer Name') . ':');
	$refPage->assign('customerNameWidthx',
			  '<input type="text" name="customerNameWidthx" id="customerNameWidthx" size="5"' .
			  'value="' . $config['customername'] . '" />');
	$refPage->assign('pdfcustomernameWidthxHelp', help('pdflistcustomername', $page));

	$refPage->assign('companyWidth', _('Company') . ':');
	$refPage->assign('companyWidthx',
			  '<input type="text" name="companyWidthx" id="companyWidthx" size="5"' .
			  'value="' . $config['company'] . '" />');
	$refPage->assign('pdfcompanyWidthxHelp', help('pdflistcompany', $page));

	$refPage->assign('taxWidth', _('Tax') . ':');
	$refPage->assign('taxWidthx',
			  '<input type="text" name="taxWidthx" id="taxWidthx" size="5"' .
			  'value="' . $config['tax'] . '" />');
	$refPage->assign('pdftaxWidthxHelp', help('pdflisttax', $page));
	
	$refPage->assign('valueWidth', _('Amount') . ':');
	$refPage->assign('valueWidthx',
			  '<input type="text" name="valueWidthx" id="valueWidthx" size="5"' .
			  'value="' . $config['value'] . '" />');
	$refPage->assign('pdfvalueWidthxHelp', help('pdflistvalue', $page));
	
	$refPage->assign('statusWidth', _('Status') . ':');
	$refPage->assign('statusWidthx',
			  '<input type="text" name="statusWidthx" id="statusWidthx" size="5"' .
			  'value="' . $config['status'] . '" />');
	$refPage->assign('pdfstatusWidthxHelp', help('pdfliststatus', $page));

	$refPage->assign('paydateWidth', _('Paydate') . ':');
	$refPage->assign('paydateWidthx',
			  '<input type="text" name="paydateWidthx" id="paydateWidthx" size="5"' .
			  'value="' . $config['paydate'] . '" />');
	$refPage->assign('pdfpaydateWidthxHelp', help('pdflistpaydate', $page));
	
	
	// Others ======================================================
	$refPage->assign('title3', _('Others'));

	$refPage->assign('rows', _('Rows per Side') . ':');
	$refPage->assign('rowsx',
			  '<input type="text" name="rowsx" id="rowsx" size="5"' .
			  'value="' . $config['rows'] . '" />');
	$refPage->assign('pdfrowsxHelp', help('pdflistrows', $page));
	
	$refPage->assign('pagination', _('Pagination') . ':');
	$refPage->assign('paginationx',
			  '<input type="text" name="paginationx" id="paginationx" size="5"' .
			  'value="' . $config['pagination'] . '" />');
	$refPage->assign('pdfpaginationxHelp', help('pdflistpagination', $page));

	$refPage->assign('font', _('Font') . ':');
	$refPage->assign('fontx',
			  '<input type="text" name="fontx" id="fontx" size="25"' .
			  'value="' . $config['font'] . '" />');
	$refPage->assign('pdffontxHelp', help('pdflistfont', $page));
	
	$refPage->assign('fontheight', _('Font height') . ':');
	$refPage->assign('fontheightx',
			  '<input type="text" name="fontheightx" id="fontheightx" size="5"' .
			  'value="' . $config['fontheight'] . '" />');
	$refPage->assign('pdffontheightxHelp', help('pdflistfontheight', $page));
	
	$refPage->assign('fonttitle', _('Title font') . ':');
	$refPage->assign('fonttitlex',
			  '<input type="text" name="fonttitlex" id="fonttitlex" size="25"' .
			  'value="' . $config['fonttitle'] . '" />');
	$refPage->assign('pdffonttitlexHelp', help('pdflistfonttitle', $page));
	
	$refPage->assign('fonttitleheight', _('Font title height') . ':');
	$refPage->assign('fonttitleheightx',
			  '<input type="text" name="fonttitleheightx" id="fonttitleheightx" size="5"' .
			  'value="' . $config['fonttitleheight'] . '" />');
	$refPage->assign('pdffonttitleheightxHelp', help('pdflistfonttitleheight', $page));
	
	
	$refPage->assign('btnSave',
			  '<input type="submit" name="submit" id="save" value="' . _('Save') . '" />');
	$refPage->assign('btnAbort', '<input type="reset" value="' . _('Abort') . '">');

	$refPage->addtpl('content', '/config/list.tpl.php');
}

?>