<?php

if (!defined('TOBBIVM'))
   header('location:/template/notrepassing.php');
/**
 * This file is part of TobbiVMShop.
 *
 * TobbiVMShop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TobbiVMShop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TobbiVMShop.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Content for page->category
 * set content in pagecategory.tpl.php for category browse
 * set content in pagecategory.editor.tpl.php for category editor
 * include functions to use in pagecategory pages
 *
 * @version    $Id$
 * @package    TobbiVM-Shop
 * @copyright  Copyright (C) 2018
 * @author     Norbert Gebert
 * @license    GPL3
 */
function contentPage($refPage, $page, $subpage, $refValidate) {
   // This if-loop get the code of sub-codes for delete, change order an activate field
   // and set the 'Output'page as category-table or category-editor
   $functions = 'module/function/page.func.php';
   if (is_file($functions))
      include_once $functions;

   $refPage->assign('pagecategoryPageHelp', help('pagecategoryPage', $page, TRUE));

   if (isset($_GET['active']))
   {  // activate or deactivate category
      $pagefile = 'module/page/page/pagecategory.page.action.php';
      if (is_file($pagefile))
         include_once $pagefile;

      $pagefile = 'module/page/page/pagecategory.page.table.php';
      if (is_file($pagefile))
         include_once $pagefile;
   }
   else if (isset($_GET['order']))
   {  // push up position of selected data record
      $pagefile = 'module/page/page/pagecategory.page.order.php';
      if (is_file($pagefile))
         include_once $pagefile;

      $pagefile = 'module/page/page/pagecategory.page.table.php';
      if (is_file($pagefile))
         include_once $pagefile;
   }
   else if (isset($_GET['func']))
   {
      if ($refValidate->cleanslash($_GET['func']) === 'edit')
      { // call the editor page of selectet category
         $pagefile = 'module/page/page/pagecategory.page.editor.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_GET['func']) === 'pagi')
      { // Display new page
         $number = intval($_GET['nr']);
         $_SESSION['pageC'] = $number;

         $pagefile = 'module/page/page/pagecategory.page.table.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_REQUEST['submit']) === _('New'))
      { // create a new category
         $data = array('pagecategory_name' => 'New');
         db::getInstance()->insert('pagecategory', $data);
         $result = db::getInstance()->rawQuery("SELECT LAST_INSERT_ID()");
         $_GET['id'] = intval($result[0]['LAST_INSERT_ID()']);
         db::getInstance()->where("pagecategory_id", $_GET['id']);
         $result = db::getInstance()->getOne("pagecategory");
         $catTopy = intval($result['pagecategory_top']);
         $result = db::getInstance()->rawQuery("SELECT count(*) FROM pagecategory " .
                 "WHERE pagecategory_top ='" . $catTopy . "'");
         $count = intval($result[0]['count(*)']);
         $data = array('pagecategory_order' => $count,
             'pagecategory_create' => date("Y-m-d H:i:s"));
         db::getInstance()->where('pagepagecategory_id', $_GET['id']);
         db::getInstance()->update('pagecategory', $data);

         // call the editor page for the new category
         $pagefile = 'module/page/page/pagecategory.page.editor.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_REQUEST['submit']) === _('Abort'))
      {
         $pagefile = 'module/page/page/pagecategory.page.table.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_REQUEST['submit']) === _('Copy'))
      { // Copy marked categoryentry 1:1
         if (!empty($_POST['marker']))
         {
            // copy category
            $pagefile = 'module/page/page/pagecategory.page.copy.php';
            if (is_file($pagefile))
               include_once $pagefile;
         }

         $pagefile = 'module/page/page/pagecategory.page.table.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_REQUEST['submit']) === _('Save'))
      { // save data from editorpage and then call categorypage
         $pagefile = 'module/page/page/pagecategory.page.save.php';
         if (is_file($pagefile))
            include_once $pagefile;

         $pagefile = 'module/page/page/pagecategory.page.table.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_REQUEST['submit']) === _('Refresh'))
      { // save data from editorpage and then call editorpage
         $pagefile = 'module/page/page/pagecategory.page.save.php';
         if (is_file($pagefile))
            include_once $pagefile;

         $pagefile = 'module/page/page/pagecategory.page.editor.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_REQUEST['submit']) === _('Delete'))
      { // open the "Delete"-Window
         if (!empty($_POST['marker']))
         {
            $pagefile = 'module/page/page/pagecategory.page.delete.php';
         } else
         {
            $pagefile = 'module/page/page/pagecategory.page.table.php';
         }

         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_GET['func']) === 'deleteNow')
      { // copy Category to basket and delete the source
         $deleteIds = explode('-', $refValidate->cleanslash($_POST['deleteId']));

         foreach ($deleteIds as $value) {
            db::getInstance()->where("pagecategory_id", $value);

            if ($cat = db::getInstance()->getOne("pagecategory"))
            {
               $catTop = $cat['pagecategory_top'];
               //db::getInstance()->rawQuery("INSERT INTO category_basket SELECT * FROM category " .
               //	"WHERE category.category_id = '" . $value . "'");
               db::getInstance()->where("pagecategory_id", $value);

               if (db::getInstance()->delete('pagecategory'))
               {
                  message::setNoteRow($cat['pagecategory_id'] . ' ' . $cat['pagecategory_name'] . ' -> ' .
                          _('Data were deleted.'));
               } else
               {
                  message::setErrorRow($cat['pagecategory_id'] . ' ' . $cat['pagescategory_name'] . ' -> ' .
                          _('Faults delete the data - move/delete.'));
               }

               $ordernr = 1;
               if ($pagecategoryx = db::getInstance()->rawQuery("SELECT pagecategory_id FROM pagecategory WHERE " .
                       "pagecategory_top ='" . $catTop . "' ORDER BY pagecategory_order"))
               {
                  foreach ($pagecategoryx as $valuex) {
                     $data = Array('pagecategory_order' => $ordernr);
                     db::getInstance()->where('pagecategory_id', $valuex['pagecategory_id']);
                     db::getInstance()->update('pagecategory', $data);
                     $ordernr++;
                  }
               }

               if (!empty($cat['pagecategory_image']))
               { // Detete image
                  if (unlink('../images/' . PAGE_CATEGORY_IMAGE_PATH . '/' . $value . '/' .
                                  $cat['pagecategory_image']))
                     message::setNoteRow($cat['pagecategory_id'] . ' ' . $cat['pagecategory_name'] . ' -> ' .
                             _('The old image file was deteted successfully. '));
               }
            }
         }
         // get the category-table
         $pagefile = 'module/page/page/pagecategory.page.table.php';
         if (is_file($pagefile))
            include_once $pagefile;
      } else if ($refValidate->cleanslash($_REQUEST['submit']) === _('Next Page'))
      {
         $_SESSION['pageC'] ++;

         $pagefile = 'module/page/page/pagecategory.page.table.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
      else if ($refValidate->cleanslash($_REQUEST['submit']) === _('Previous Page'))
      {
         $_SESSION['pageC'] --;

         $pagefile = 'module/page/page/pagecategory.page.table.php';
         if (is_file($pagefile))
            include_once $pagefile;
      }
   }
   else
   {  // get the category-table
      $pagefile = 'module/page/page/pagecategory.page.table.php';
      if (is_file($pagefile))
         include_once $pagefile;
   }
}

/**
 * New numbering of the source category (after delete/move) and
 * new order number for the target category (new or moved categorys be appended to it)
 *
 * @param  string $newCategory	Target category-id
 * @param  string $oldCategory	Erorcode for output
 * @return new order-value as numeric
 */
function sortOrder($newPageCategoryTopx, $oldPageCategoryTopx, $idx) {
   $resultx = db::getInstance()->rawQuery("SELECT pagecategory_id, pagecategory_order, " .
           "pagecategory_top FROM pagecategory WHERE pagecategory_top = '" . $oldPageCategoryTopx . "'" .
           " ORDER BY pagecategory_order");

   $orderCount = 0;

   if (count($resultx) > 1)
   {
      foreach ($resultx as $dbRow) {
         $orderCount++;

         if ($dbRow['pagecategory_id'] == $idx)
         {
            $orderCount--;
         }

         $data = Array('pagecategory_order' => $orderCount);
         db::getInstance()->where('pagecategory_id', $dbRow['pagecategory_id']);
         db::getInstance()->update('pagecategory', $data);
      }
   }
   db::getInstance()->where('pagecategory_top', $newPageCategoryTopx);
   $result = db::getInstance()->get('pagecategory');
   $orderCount = count($result) + 1;
   return $orderCount;
}

?>