<?php

/**
 * This file is part of TobbiVMShop.
 *
 * TobbiVMShop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TobbiVMShop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TobbiVMShop.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Datei: buffer.class.php
 *
 * Stores config-values in session-array
 * 
 * @since 0.1.2
 * @version 0.1.2
 * @package TobbiVM-Shop
 * @copyright Copyright (C) 2018
 * @license GPL3
 * @category install
 * @package install
 * @subpackage install
 * $Rev: 29 $
 * $Date: 2018-08-13 12:19:28 +0200 (Mo, 13. Aug 2018) $
 * $Author: norbert-neo $
 * $URL: https://svn.code.sf.net/p/tobbivm/code/trunk/install/buffer.class.php $
 */
class buffer
{

   /**
    * Initializes the session-array 
    */
   function __construct() {
      if (!isset($_SESSION['url_0']))
         $_SESSION['url_0'] = '';
      if (!isset($_SESSION['url_1']))
         $_SESSION['url_1'] = '';
      if (!isset($_SESSION['url_2']))
         $_SESSION['url_2'] = '';
      if (!isset($_SESSION['url_3']))
         $_SESSION['url_3'] = '';
      if (!isset($_SESSION['url_4']))
         $_SESSION['url_4'] = '';
      if (!isset($_SESSION['url_5']))
         $_SESSION['url_5'] = '';
      if (!isset($_SESSION['url']))
         $_SESSION['url'] = '';

      if (!isset($_SESSION['template']))
         $_SESSION['template'] = '';

      if (!isset($_SESSION['dbname']))
         $_SESSION['dbname'] = '';
      if (!isset($_SESSION['dbHost']))
         $_SESSION['dbHost'] = '';
      if (!isset($_SESSION['dbUser']))
         $_SESSION['dbUser'] = '';
      if (!isset($_SESSION['dbPassword']))
         $_SESSION['dbPassword'] = '';
      if (!isset($_SESSION['adminMail']))
         $_SESSION['adminMail'] = '';
      if (!isset($_SESSION['testshopper']))
         $_SESSION['testshopper'] = '';
      if (!isset($_SESSION['http_s']))
         $_SESSION['http_s'] = '';
      /*       * ------------------------------------------------- */
      if (!isset($_SESSION['shortUrl']))
         $_SESSION['shortUrl'] = '';
      if (!isset($_SESSION['canonicalUrl']))
         $_SESSION['canonicalUrl'] = '';

      if (!isset($_SESSION['mailHost']))
         $_SESSION['mailHost'] = '';
      if (!isset($_SESSION['mailUser']))
         $_SESSION['mailUser'] = '';
      if (!isset($_SESSION['mailPassword']))
         $_SESSION['mailPassword'] = '';
      if (!isset($_SESSION['mailPort']))
         $_SESSION['mailPort'] = '25';
      if (!isset($_SESSION['mailAuth']))
         $_SESSION['mailAuth'] = '1';
      if (!isset($_SESSION['mailSenderAdress']))
         $_SESSION['mailSenderAdress'] = '';
      if (!isset($_SESSION['mailSenderName']))
         $_SESSION['mailSenderName'] = '';
      if (!isset($_SESSION['mailSendRevo']))
         $_SESSION['mailSendRevo'] = '';
      if (!isset($_SESSION['mailSendTerms']))
         $_SESSION['mailSendTerms'] = '';
      if (!isset($_SESSION['mailToCustomer']))
         $_SESSION['mailToCustomer'] = '';
      /*       * ------------------------------------------------- */
      if (!isset($_SESSION['compName']))
         $_SESSION['compName'] = '';
      if (!isset($_SESSION['compStreet']))
         $_SESSION['compStreet'] = '';
      if (!isset($_SESSION['compCity']))
         $_SESSION['compCity'] = '';
      if (!isset($_SESSION['compIntPhone']))
         $_SESSION['compIntPhone'] = '';
      if (!isset($_SESSION['compPhone']))
         $_SESSION['compPhone'] = '';
      if (!isset($_SESSION['compFax']))
         $_SESSION['compFax'] = '';
      if (!isset($_SESSION['compMail']))
         $_SESSION['compMail'] = '';
      /*       * ------------------------------------------------- */
      if (!isset($_SESSION['titel']))
         $_SESSION['titel'] = '';
      if (!isset($_SESSION['Metadescription']))
         $_SESSION['Metadescription'] = '';
      if (!isset($_SESSION['generator']))
         $_SESSION['generator'] = '';
      /*       * ------------------------------------------------- */
      if (!isset($_SESSION['logCompany']))
         $_SESSION['logCompany'] = '1';
      if (!isset($_SESSION['logFirstname']))
         $_SESSION['logFirstname'] = '2';
      if (!isset($_SESSION['logLastname']))
         $_SESSION['logLastname'] = '2';
      if (!isset($_SESSION['logStreet']))
         $_SESSION['logStreet'] = '2';
      if (!isset($_SESSION['logZipcode']))
         $_SESSION['logZipcode'] = '2';
      if (!isset($_SESSION['logCity']))
         $_SESSION['logCity'] = '2';
      if (!isset($_SESSION['logCountry']))
         $_SESSION['logCountry'] = '2';
      if (!isset($_SESSION['logState']))
         $_SESSION['logState'] = '0';
      if (!isset($_SESSION['logPhone']))
         $_SESSION['logPhone'] = '2';
      if (!isset($_SESSION['logFax']))
         $_SESSION['logFax'] = '1';
      if (!isset($_SESSION['logMobile']))
         $_SESSION['logMobile'] = '1';
      if (!isset($_SESSION['logMail']))
         $_SESSION['logMail'] = '2';
      /* ------------------------------------------------- */
      if (!isset($_SESSION['suffix']))
         $_SESSION['suffix'] = '';
   }

   /**
    * buffer the template setting
    */
   public static function setTemplate() {
      if (isset($_POST['r1']))
         $_SESSION['template'] = $_POST['r1'];
   }

   /**
    * read template setting and returns "checked" if set
    * @param int $number set if option selectet 0 or 1
    * @return NULL|string HTML-string for input-field
    */
   public static function getTemplate($number) {
      if ($_SESSION['template'] == $number)
         return 'checked="checked"';
      else
         return '';
   }

   /**
    * buffer the adress settings
    */
   public static function setAdress() {
      if (isset($_POST['compName']))
         $_SESSION['compName'] = $_POST['compName'];
      if (isset($_POST['compStreet']))
         $_SESSION['compStreet'] = $_POST['compStreet'];
      if (isset($_POST['compCity']))
         $_SESSION['compCity'] = $_POST['compCity'];
      if (isset($_POST['compIntPhone']))
         $_SESSION['compIntPhone'] = $_POST['compIntPhone'];
      if (isset($_POST['compPhone']))
         $_SESSION['compPhone'] = $_POST['compPhone'];
      if (isset($_POST['compFax']))
         $_SESSION['compFax'] = $_POST['compFax'];
      if (isset($_POST['compMail']))
         $_SESSION['compMail'] = $_POST['compMail'];

      if (isset($_POST['mailHost']))
         $_SESSION['mailHost'] = $_POST['mailHost'];
      if (isset($_POST['mailUser']))
         $_SESSION['mailUser'] = $_POST['mailUser'];
      if (isset($_POST['mailPassword']))
         $_SESSION['mailPassword'] = $_POST['mailPassword'];
      if (isset($_POST['mailPort']))
         $_SESSION['mailPort'] = $_POST['mailPort'];
      if (isset($_POST['mailSenderAdress']))
         $_SESSION['mailSenderAdress'] = $_POST['mailSenderAdress'];
      if (isset($_POST['mailSenderName']))
         $_SESSION['mailSenderName'] = $_POST['mailSenderName'];
      self::setOption('mailSendRevo');
      self::setOption('mailSendTerms');
      self::setOption('mailToCustomer');
   }

   /**
    * buffer the database settings
    */
   public static function setDatabase() {
      if (isset($_POST['dbname']))
         $_SESSION['dbname'] = $_POST['dbname'];
      if (isset($_POST['dbHost']))
         $_SESSION['dbHost'] = $_POST['dbHost'];
      if (isset($_POST['dbUser']))
         $_SESSION['dbUser'] = $_POST['dbUser'];
      if (isset($_POST['dbPassword']))
         $_SESSION['dbPassword'] = $_POST['dbPassword'];
      if (isset($_POST['adminMail']))
         $_SESSION['adminMail'] = $_POST['adminMail'];

      if (isset($_POST['url_0']))
         $_SESSION['url_0'] = $_POST['url_0'];
      self::setOption('http_s');
      if (isset($_POST['shortUrl']))
         $_SESSION['shortUrl'] = $_POST['shortUrl'];
      if (isset($_POST['testshopper']))
         $_SESSION['testshopper'] = $_POST['testshopper'];
      if (isset($_POST['titel']))
         $_SESSION['titel'] = $_POST['titel'];
      if (isset($_POST['Metadescription']))
         $_SESSION['Metadescription'] = $_POST['Metadescription'];
      if (isset($_POST['generator']))
         $_SESSION['generator'] = $_POST['generator'];

      self::setOption('logCompany');
      self::setOption('logFirstname');
      self::setOption('logLastname');
      self::setOption('logStreet');
      self::setOption('logZipcode');
      self::setOption('logCity');
      self::setOption('logCountry');
      self::setOption('logPhone');
      self::setOption('logFax');
      self::setOption('logMobile');
      self::setOption('logMail');
   }

   /**
    * buffer option setting
    */
   public static function setOption($name) {
      if (isset($_POST[$name]))
         $_SESSION[$name] = $_POST[$name];
      else
         $_SESSION[$name] = '';
   }

   /**
    * get option setting as TRUE-/FALSE-String
    * @param keyword $name name of session-variable to use
    * @return boolean true or false if var 0 or 1
    */
   public static function getOptionL($name) {
      if ($_SESSION[$name] <> '')
         return 'TRUE';
      else
         return 'FALSE';
   }

   /**
    * read option setting
    * @param keyword $name name of session-variable to use
    * @return boolean true or false if var 0 or 1
    */
   public static function getOption($name) {
      if ($_SESSION[$name] <> '')
         return 'checked="checked"';
      else
         return '';
   }

   /**
    * read radio setting
    * @param keyword $name name of session-variable to use
    * @param int $number value of session-variable
    * @return boolean true or false if var 0 or 1
    */
   public static function getRadio($name, $number) {
      if ($_SESSION[$name] <> '')
         if ($_SESSION[$name] == $number)
            return 'checked="checked"';
         else
            return '';
   }

   /**
    * send Test-Mail
    * On error print a string to screen
    */
   public static function testMail() {
      require 'email/PHPMailerAutoload.php';
      //PHPMailer Object
      $mail = new PHPMailer;
      //Tell PHPMailer to use SMTP
      $mail->isSMTP();
      $mail->SMTPDebug = 0;
      $mail->Debugoutput = 'html';
      $mail->SMTPAuth = TRUE;

      // Set mailserver-data
      $mail->CharSet = 'utf-8';
      $mail->Host = $_SESSION['mailHost'];
      $mail->Port = $_SESSION['mailPort'];
      $mail->Username = $_SESSION['mailUser'];
      $mail->Password = $_SESSION['mailPassword'];

      //From email address and name
      $mail->From = $_SESSION['mailSenderAdress'];
      $mail->FromName = $_SESSION['mailSenderName'];

      //To address and name
      $mail->addAddress($_SESSION['mailSenderAdress'], $_SESSION['mailSenderName']);
      //Address to which recipient will reply
      $mail->addReplyTo($_SESSION['mailSenderAdress'], "Reply");

      //Send HTML or Plain Text email
      $mail->isHTML(true);

      $mail->Subject = "Testmail von TobbiVM-Shop";
      $mail->Body = '<h2>Gratulation!</h2>' .
              'Die angegebenen Daten des Mailservers sind richtig.' .
              'Die Installation kann fortgesetzt werden.';
      $mail->AltBody = 'Gratulation!' .
              'Die angegebenen Daten des Mailservers sind richtig.' .
              'Die Installation kann fortgesetzt werden.';

      if (!$mail->send())
      {
         echo "Mailer Error: " . $mail->ErrorInfo;
      }
   }

   /**
    * Test connection to database-server
    * @return string status of connection
    */
   public static function testDb() {
      $mysqli = new mysqli($_SESSION['dbHost'], $_SESSION['dbUser'], $_SESSION['dbPassword'], $_SESSION['dbname']);
      if ($mysqli->connect_errno)
         return '<b>Es konnte keine Verbindung zur Datenbank und/oder Datenbanktabelle hergestellt werden!</b><br>' .
                 '(' . $mysqli->connect_error . ')';
      else
         return 'Verbindung zur Datenbank konnte erfolgreich hergestellt werden.';
      die("Verbindung fehlgeschlagen: " . $mysqli->connect_error);
   }

}
