<?php

if (!defined('TOBBIVM'))
   header('location:/template/notrepassing.php');
/**
 * This file is part of TobbiVMShop.
 *
 * TobbiVMShop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TobbiVMShop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TobbiVMShop.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * create pages-detail browse page
 * get: XXX.tpl.php
 * used from core.php
 *
 * @version    $Id$
 * @package    TobbiVM-Shop
 * @copyright  Copyright (C) 2018
 * @author     Norbert Gebert
 * @license    GPL3
 */
function contentPage($refPage, $page, $title, $name, $refValidate) {
   // Lightbox-Function
   $pagefile = 'module/function/lightbox.func.php';
   if (is_file($pagefile))
      include_once($pagefile);
   
   // Read pages-data from the selectet page
   db::getInstance()->where('pages_id', $title);
   db::getInstance()->where('pages_active' . SUFFIX, '1');
   $result = db::getInstance()->getOne('pages');

   if (!empty($result['pages_title']))
      $refPage->assign('templateTitel', $result['pages_title']);

   // Create metakeys and -description
   if (!empty($result['pages_metakey'])) {
      $meta = $result['pages_metakey'] . ', ' . META_KEYWORDS;
      $metax = explode(',', $meta);
      $meta = '';

      for ($i = 0; $i < META_KEYWORD_NUMBER; $i++) {
         $meta .= $metax[$i];
         if ($i < META_KEYWORD_NUMBER - 1)
            $meta .= ',';
      }
      $refPage->assign('Metakeywords', $meta);
   }

   if (!empty($result['pages_metadescription'])) {
      $meta = $result['pages_metadescription'] . ', ' . META_DESCRIPTION;
      $meta = substr($meta, 0, META_DESCRIPTION_LENGH - 1) . '&hellip;';
      $refPage->assign('Metadescription', $meta);
   }

   $pagefile = 'module/function/pagescounter.php';
   if (is_file($pagefile))
      include_once($pagefile);

   // Pagetext
   $pageText = placeholder::replace($result['pages_text']);
   $pageText = lightbox($pageText);
   $pageText = xplugin::getPluginCode($pageText);
   $texte = explode('{BOTTOM}', $pageText);

   $refPage->assign('textTop', $texte[0]);

   if (count($texte) == 2)
      $refPage->assign('textBottom', $texte[1]);
   else
      $refPage->assign('textBottom', '');

   $refPage->assign('name', $result['pages_name']);
   $refPage->assign('createdate', $result['pages_create']);
   $refPage->assign('changedate', $result['pages_last_change']);

// Create image path
   $attribute = '';
   $attribute .= '" alt="' . $result['pages_image_alt'];
   $attribute .= '" title="' . $result['pages_image_title'];

   $refPage->assign('image', '/images/' . PAGES_IMAGE_PATH . '/' . $result['pages_category'] . '/' .
           $result['pages_image'] . $attribute);


   placeholder::setPage($refPage);

   $refPage->addtpl('content', 'pages.browse/' . $result['pages_browsepage'] .
           '.tpl.php');
}
