<?php
if (!defined('TOBBIVM')) header('location:/template/notrepassing.php');
/**
 * This file is part of TobbiVMShop.
 *
 * TobbiVMShop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TobbiVMShop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TobbiVMShop.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * Invoice email-template
 * used from cart.save.php
 * To format the email you use tags like style= / font / table e.g.
 * Don't use css-file for mails! The logo(s) in the mail are embedded
 * in the mail.
 * To make the positioning easier the unit mm be used.
 * @version    $Id: invoice.mail.tpl.php 12 2018-07-17 06:40:17Z norbert-neo $
 * @package    TobbiVM-Shop
 * @copyright  Copyright (C) 2012
 * @author     Norbert Gebert
 * @license    GPL3
 */
/**
 * Usable Elements
 * 
 * {logo1}          Image1 Filename: logo1email Code: <img {logo1} />
 * {logo2}          Image2 Filename: logo2email Code: <img {logo2} />
 * {logo3}          Image3 Filename: logo3email Code: <img {logo3} />
 * {company}        Shopper companyname
 * {name}           Shopper first- and lastname
 * {street}         Shopper street and number
 * {city}           Shopper zip +and countryname
 * {phone}          Shopper phonenumber(s]
 * {email}          Shopper mailadress
 * {mobile}         Shopper mobile phonenumber
 * {fax}            Shopper faxnumber
 * {companyname}    Vendor companyname
 * {companystreet}  Vendor streen and number
 * {companycity}    Vendor zip and country
 * {companyphone}   Vendor phonenumber
 * {companyfax}     Vendor faxnumber
 * {companyemail}   Vendor mailadress
 * {ordernumber}    Ordernumber
 * {customernumber} Customernumber
 * {orderdate}      Orderdate
 * 
 *  <!-- BEGIN productList -->      Start Array output
 * {sku}            Productnumber
 * {product}        Product description
 * {pricePerItem}   Single price
 * {number}         Number of buyes items
 * {priceTotal}     Totalprice
 *  <!-- END productList -->        End Array output
 * 
 * {shippingPrice}  Calculatet shippingcosts
 * {price}          Ordertotal price
 * 
 *  <!-- BEGIN tax -->              Start Array output
 * {taxname}        Taxname
 * {percent}        Percent value of Tax
 * {value}          Value of Tax
 *  <!-- END tax -->                End Array output
 * 
 * {comment}        Shopper comment
 * {payment}        Info for shopper to paymentprocess
 * {footer}         Footertext
 * {revocation}     Revocationtext
 * {terms}          Termstext
 */
?>
<div style="min-height:280mm; max-width:210mm; overflow:hidden;
     font-family:Verdana, Arial, Helvetica; color:#555555; font-size:0.9em;">

    <table cellpadding="0" cellspacing="0" 			 
           style="margin-top:10mm; margin-left:20mm; width:180mm;">
        <tbody>
            <tr>
                <td style="width:85mm; padding-top:40mm; font-size:1em;" rowspan="2">
                    <br>
                    {company}<br>
                    {name}<br>
                    {street}<br>
                    {city}<br>
						  <br> 
						  E-Mail: {email}<br>
						  Telefon: {phone}<br>
						  Fax: {fax}<br>
						  Mobil: {mobile}<br>
                </td>
                <td align="right" style="with:95mm;">
                    <img {logo1}/>
                </td>
            </tr>
            <tr>
                <td style="padding-left:60mm; with:95mm; align:right;"> 
                    <span style="width:95mm; text-align:left;"> 
                        {companyname}<br>
                        {companystreet}<br>
                        {companycity}<br><br>
                        Telefon: {companyphone}<br>
                        Fax: {companyfax}<br>
                        Email: {companyemail}
                    </span>
                </td>
            </tr>
        </tbody>
    </table>

    <div style="margin-top:15mm; margin-left:20mm;">
        <h2><b>Auftrag-/Rechnung-Nr. {ordernumber}</b></h2>
    </div>

    <table cellpadding="0" cellspacing="0" style="margin-top:4mm; margin-left:20mm;width:180mm;">
        <tbody>
            <tr>
                <th style="width:120mm; vertical-align:bottom; text-align:left; padding-right:3mm;">
                    Artikel
                </th>
                <th style="width:20mm; vertical-align:bottom; text-align: right; padding-right:3mm;">
                    Stück-<br>preis
                </th>
                <th style="width:20mm; vertical-align:bottom; text-align: right; padding-right: 3mm;">
                    Menge
                </th>
                <th style="width:20mm; vertical-align:bottom; text-align:right;">
                    Preis
                </th>
            </tr>

            <!-- BEGIN productList -->
            <tr>
                <td style="width:120mm; text-align:left; padding-right:3mm;">
                    {sku}<br>
                    {product}
                </td>
                <td style="width:20mm; text-align: right; padding-right:3mm;">
                    {pricePerItem}
                </td>
                <td style="width:20mm; text-align: right; padding-right: 3mm;">
                    {number}
                </td>
                <td style="width:20mm; text-align:right;">
                    {priceTotal}
                </td>
            </tr>
            <!-- END productList -->

            <tr>
                <td valign="top" colspan="3"></td>
                <td valign="top">
                    <hr size="2" width="90%">
                </td>
            </tr>

            <tr>
                <td align="right" valign="top" colspan="3">
                    Versandkosten: 
                </td>
                <td valign="top" style="text-align:right; vertical-align:bottom;">
                    {shippingPrice}
                </td>
            </tr>

            <tr>
                <td valign="top" colspan="3"></td>
                <td valign="top">
                    <hr size="2" width="90%">
                </td>
            </tr>

            <tr>
                <td align="right" colspan="3">
                    Gesamtsumme:
                </td>
                <td style="text-align:right; font-weight: bold;">
                    {price}
                </td>
            </tr>
            <tr>
                <td style="width:180mm; text-align:right; font-weight:normal;
                    font-size: 0.8em;" colspan="4">
                    <!-- BEGIN tax -->
                    (enthaltene {taxname} ({percent}%) {value})<br>
                    <!-- END tax -->
                </td>
            </tr>
            <tr>
                <td style="text-align:left; font-weight:normal;
                    font-size: 0.9em;" colspan="4">
                    <br>
                    {comment}
                    {payment}
                </td>
            </tr>
        </tbody>
    </table>


    <div style="max-width:210mm; overflow:hidden; font-family:Verdana, Arial, Helvetica; color:#555555; font-size:0.9em;">
        <div style="text-align:center; margin-top:5mm; margin-left:20mm; width:180mm;">
            <div>
                <hr>
                {footer}
            </div>
            <br><br>
            <div style="text-align:left;">
                {revocation}
                <br><br>
                {terms}
            </div>
        </div>
    </div>
</div>